/* interfac.h */

#include <stdio.h>
#include <graphics.h>
#include <dos.h>
#include <bios.h>
#include "velha.h"
#include "interfac.h"


#ifdef PC

void interrupt far (*velho_clock_int)(void);

int linha = 1,
    coluna = 1;

/* cursor: Produz um cursor intermitente em modo grafico.
   Recebe: Nada.
   Retorna: Nada. */

void interrupt far cursor (void)
{
  static int linha_ant = 1,
	     coluna_ant = 1,
	     passagem = 0;
  int cor, pos_x, pos_y;

  if (linha < 1)
    linha = 1;
  if (linha > 3)
    linha = 3;
  if (coluna < 1)
    coluna = 1;
  if (coluna > 3)
    coluna = 3;
  if (passagem++ == 3) {
    cor = getcolor ();
    pos_x = 80 + (coluna - 1) * 60 + 4;
    pos_y = 20 + (linha - 1) * 40 + 4;
    setcolor (VERMELHO);
    rectangle (pos_x, pos_y, pos_x + 52, pos_y + 32);
    setcolor (cor);
    linha_ant = linha;
    coluna_ant = coluna;
    return;
  }
  if (passagem == 6) {
    cor = getcolor ();
    pos_x = 80 + (coluna_ant - 1) * 60 + 4;
    pos_y = 20 + (linha_ant - 1) * 40 + 4;
    setcolor (PRETO);
    rectangle (pos_x, pos_y, pos_x + 52, pos_y + 32);
    setcolor (cor);
    passagem = 0;
    return;
  }
}


/* inicializa_video: Produz a tela de interface com a pessoa.
   Recebe: Nada.
   Retorna: Nada. */

void inicialize_video (void)
{
  int gd,
      gm;

  gd = CGA;
  gm = CGAC0;
  initgraph (&gd, &gm, ".");

  settextstyle (DEFAULT_FONT, HORIZ_DIR, 3);
  setcolor (VERDE);
  outtextxy (5, 20, "V");
  outtextxy (5, 50, "E");
  outtextxy (5, 80, "L");
  outtextxy (5, 110, "H");
  outtextxy (5, 140, "A");

  setlinestyle (DASHED_LINE, EMPTY_FILL, 1);
  setcolor (VERMELHO) ;
  rectangle (40, 5, 310, 195);

  setcolor (AMARELO);
  setlinestyle (SOLID_LINE, EMPTY_FILL, 3);
  line (140, 20, 140, 140);
  line (200, 20, 200, 140);
  line (80, 60, 260, 60);
  line (80, 100, 260, 100);

  settextstyle (SMALL_FONT, HORIZ_DIR, 0);
  imprima (75, 160, "Use as setas para mover o");
  imprima (65, 170, "cursor, <Enter> para  jogar");
  imprima (75, 180, "ou <Esc> para configurar.");

}

void retire_cursor (void)
{
  int pos_x,
      pos_y,
      cor;

  cor = getcolor ();
  pos_x = 80 + (coluna - 1) * 60 + 4;
  pos_y = 20 + (linha - 1) * 40 + 4;
  setcolor (PRETO);
  rectangle (pos_x, pos_y, pos_x + 52, pos_y + 32);
  setcolor (cor);

}
void assinale_circulo (int linha, int coluna)
{
  int pos_x,
      pos_y,
      angulo;

  pos_x = 80 + (coluna - 1) * 60 + 30;
  pos_y = 20 + (linha - 1) * 40 + 20;
  setcolor (VERDE);
  for (angulo = 0; angulo < 360; angulo += 2) {
    arc (pos_x, pos_y, angulo, angulo + 1, 18);
    arc (pos_x, pos_y, angulo, angulo + 1, 17);
    arc (pos_x, pos_y, angulo, angulo + 1, 16);
  }
  setlinestyle (SOLID_LINE, EMPTY_FILL, 3);
}

void assinale_cruz (int linha, int coluna)
{
  int pos_x,
      pos_y,
      cont_x,
      cont_y;

  pos_x = 80 + (coluna - 1) * 60 + 10;
  pos_y = 20 + (linha - 1) * 40 + 10;
  setcolor (VERDE);
  for (cont_x = pos_x, cont_y = pos_y; cont_x < pos_x + 40;
       cont_x += 2, cont_y++) {
    line (cont_x, cont_y, cont_x + 1, cont_y + 1);
    delay (30);
  }
  delay (100);
  for (cont_x = pos_x + 40, cont_y = pos_y; cont_x > pos_x;
       cont_x -= 2, cont_y++) {
    line (cont_x, cont_y, cont_x - 1, cont_y + 1);
    delay (30);
  }
}


/* receba_movimento: Recebe o movimento da peca da pessoa.
   Recebe: O tabuleiro atual por referencia.
   Retorna: O tabuleiro ja com o movimento. */


void receba_movimento (tipo_tabuleiro *atual)
{
  int varredura,
      tecla;

  velho_clock_int = getvect (CLOCK);
  setvect (CLOCK, cursor);
  do {
    while ((varredura = bioskey (1)) == 0)
    ;
    tecla = getch ();
    switch (varredura) {
      case SOBE:
	if (--linha < 1)
	  linha = 1;
	getch ();
	break;
      case DESCE:
	if (++linha > 3)
	  linha = 3;
	getch ();
	break;
      case DIREITA:
	if (++coluna > 3)
	  coluna = 3;
	getch ();
	break;
      case ESQUERDA:
	if (--coluna < 1)
	  coluna = 1;
	getch ();
	break;
      default: {
	if (tecla == ENTER) {
	  if ((*atual).tabuleiro [linha - 1] [coluna - 1] != VAZIO)
	    tecla = 0;
	  else
	    (*atual).tabuleiro [linha - 1] [coluna - 1] = CRUZ;
	}
      }
    }
  } while (tecla != ENTER);
  setvect (CLOCK, velho_clock_int);
  retire_cursor ();
  assinale_cruz (linha, coluna);
}

void imprima (int x, int y, char *mensagem)
{
  int cont = 0;
  char letra [2];

  letra [1] = '\0';
  moveto (x, y);
  for (; mensagem [cont] != '\0'; cont++) {
    delay (50);
    letra [0] = mensagem [cont];
    outtext (letra);
  }
}




/* mostre_tabuleiro: Reproduz um tabuleiro no video.
   Recebe: O tabuleiro.
   Retorna Nada. */

void mostre_tabuleiro (tipo_tabuleiro tabl)
{
  int linha,
      coluna;

  for (linha = 0; linha < 3; linha++) {
    for (coluna = 0; coluna < 3; coluna++) {
      putc (tabl.tabuleiro [linha] [coluna], stdout);
      if (coluna != 2)
	putc ('|', stdout);
    }
    if (linha != 2)
      printf ("\n-+-+-\n");
    else
      putc ('\n', stdout);
  }
}

#else

/* receba_movimento: Recebe o movimento da peca da pessoa.
   Recebe: O tabuleiro atual por referencia.
   Retorna: O tabuleiro ja com o movimento. */


void receba_movimento (tipo_tabuleiro *atual)
{

  int linha,
      coluna;

  mostre_tabuleiro (*atual);

  printf ("Entre linha e coluna: ");
  scanf ("%d %d", &linha, &coluna);
  *atual.tabuleiro [--linha] [--coluna] = CRUZ;

}

#endif
